<?php
/**
 * @package SJ Carousel for SobiPro
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2014 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */


defined('_JEXEC') or die;

require_once dirname(__FILE__) . '/sjspdefine.php';

if (!class_exists('JFormFieldSjSpSection')) {
	class JFormFieldSjSpSection extends JFormField
	{

		protected $type = 'SjSpSection';

		protected function getInput()
		{
			$file_config = SOBI_PATH . DS . 'lib' . DS . 'base' . DS . 'fs' . DS . 'loader.php';
			if (file_exists($file_config)) {
				require_once($file_config);
				SPLoader::loadClass('base.request');
				SPLoader::loadClass('base.const');
				SPLoader::loadClass('base.factory');
				SPLoader::loadClass('base.object');
				SPLoader::loadClass('sobi');
				SPLoader::loadClass('base.config');
				SPLoader::loadClass('base.exception');
				SPLoader::loadClass('cms.base.lang');
				SPLoader::loadClass('mlo.input');
				SPFactory::config()->set('live_site', JURI::root());
				$sections = array();
				$sout = array();
				try {
					$sections = SPFactory::db()
						->select('*', 'spdb_object', array('oType' => 'section'), 'id')
						->loadObjectList();
				} catch (SPException $x) {
					trigger_error('sobipro|admin_panel|cannot_get_section_list|500|' . $x->getMessage(), SPC::WARNING);
				}

				if (count($sections)) {
					SPLoader::loadClass('models.datamodel');
					SPLoader::loadClass('models.dbobject');
					SPLoader::loadModel('section');
					$sout = array();
					foreach ($sections as $section) {
						$_section = SPFactory::Section($section->id);
						$catids_all = $_section->getChilds('category');
						if (Sobi::Can('section', 'access', 'valid', $_section->get('id')) && !empty($catids_all)) {
							$sout[$_section->get('id')] = $_section->get('name');
						}
					}
				}
				$field = SPHtml_Input::select($this->name, $sout, $this->value, false, array('id' => $this->id, 'class' => 'text_area', 'style' => 'min-width: 148px;'));
				return $field;

			} else {
				$html[] = "<div style='clear:both; margin: 0 0 0 150px; font-weight:bold; color:red;'>";
				$html[] = JText::_('Sobipro component is not installed?');
				$html[] = "</div>";
				return implode("\n", $html);
			}
		}
	}
}