<?php
/**
 * @package SJ Carousel for SobiPro
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2014 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */


defined('_JEXEC') or die;

include_once dirname(__FILE__) . '/helper_base.php';

class SPGeomapHelper extends SPGeomapBaseHelper
{
	public static function getList($params)
	{
		/**
		 * Process Section
		 */
		$sid = $params->get('sid', 0);
		$objData = SPFactory::object($sid);
		$name = $objData->name;
		$nid = $objData->nid;
		$section = SPFactory::Section($sid);
		if ($section->get('state') <= 0) return;

		/**
		 * Process Categories
		 */

		$catids = $params->get('catid', 0);
		
		settype($catids, 'array');
		if (empty($catids)) return;
		$catids_all = $section->getChilds('category', true, 1);
		if (empty($catids_all)) return;
		$_catids = array();
		foreach ($catids as $catid) {
			if (in_array($catid, $catids_all)) {
				$_catids[] = (int)$catid;
			}
		}

		if (empty($_catids)) return;
		$items = self::_getEntry($_catids, $params);
		if (empty($items)) return;
		$list = array();
		$field_description = $params->get('field_description', 'field_description');
		$field_price = $params->get('field_price', 'field_price');
		$field_icon = $params->get('field_icon', 'field_icon');
		$field_country = $params->get('field_country', 'field_country');
		$field_city = $params->get('field_city', 'field_city');
		$field_street = $params->get('field_street', 'field_street');
		$data = array();
		$array_list = array();
		foreach ($items as $item) {
			$item->_id = $item->get('id');
			$item->title = $item->get('name');
			$item->_author = $item->get('metaAuthor');
			$item->_counter = $item->get('counter');
			$item->_count = $item->get('_count');
			$item->_approved = $item->get('approved');
			$item->_textarea = self::_getFieldValues($item, $field_description);
			$item->_description = self::_cleanText($item->_textarea);
			$_price = self::_getFieldValues($item, $field_price);
			$item->_price = is_numeric($_price) ? SPLang::currency($_price) : $_price;
			$item->link = $item->url;
			$data['id'] = $item->_id;
			$data['city'] = ucwords(self::getField($item->_id,$field_city,$sid));
			$data['country'] = self::getFieldCountry($item->_id,$field_country,$sid);
			$data['street'] = self::getField($item->_id,$field_street,$sid);
			$dataE = self::getEntryName($item->_id);
			$data['nameE'] = self::getEntryNamea($item->_id,'field_name',$sid);
			$data['nidE'] = $dataE->nid;
			$data['price'] = self::getField($item->_id,$field_price,$sid);
			$data['image'] = self::getEntryImage($item->_id,$field_icon,$sid);
			$array_list[] = $data;
			$list[] = $item;
		}
		$return = array();
		$return['cls_entry'] = $list;
		$return['array_entry'] = $array_list;
		return $return;
	}

	public static function _getEntry($_catids, $params)
	{
		/**
		 * Process Child Category Entries
		 */

		if ($params->get('show_child_category_entries', 0) && (int)$params->get('levels', 0) > 0) {
			$levels = $params->get('levels', 1) ? $params->get('levels', 1) : 9999;
			$_catids = self::_getChildrenCategory($_catids, $levels);
		}

		/**
		 * Process Entries
		 */

		$eOrder = $params->get('entry_ordering', 'position.asc');
		$eLimit = $params->get('entriesLimit', 5);
		$eLimit = ($eLimit < 0) ? 0 : $eLimit;
		$entry_ids = array();
		$controller = SPFactory::Controller('section', true);
		!is_array($_catids) && settype($_catids, 'array');
		if (empty($_catids)) return;
		$_items = $controller->getEntries($eOrder, $eLimit, $eLimStart = 0, $count = false, $conditions = array(), false, $_catids);
		if (!empty($_items)) {
			foreach ($_items as $ent_id) {
				$entry_ids[] = (int)$ent_id;
			}
		}
		$entry_ids = array_unique($entry_ids);
		if (empty($entry_ids)) return;
		$items = array();
		foreach ($entry_ids as $ent_id) {
			$entry_model = SPFactory::Model('entry');
			$items[] = $entry_model->init($ent_id);
		}

		return $items;
	}
	
	public static function getCoordinates($data,$type){
		if($type == 1){
			$data = str_replace(',','',$data);
			$data = str_replace(' ','+',$data);
			$json = file_get_contents('https://maps.googleapis.com/maps/api/geocode/json?address='.$data.'&sensor=true');
			$content = json_decode($json);
			$location = $content->results[0]->geometry->location;
			$return = array();
			$return['lat'] = $location->lat;
			$return['lng'] = $location->lng;			
			$return['index'] = JRequest::getVar('index');	
			$return['check_module_geomap'] = JRequest::getVar('check_module_geomap');
			
			return $return;
		}
	}
	/* ---------------------------------------------------------------------------------------------- */
	public static function getEntryNamea($id,$field,$id_c){
		$id_field = self::getIdField($field,$id_c);
		if($id_field == '')return'';
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('baseData')
							->from('#__sobipro_field_data')
							->where('sid = ' . $id)
							->where('fid = '.$id_field);
		$db->setQuery($query);
		$item = $db->loadObject();
		if(count($item) == 0)return '';
		return $item->baseData;
	}
	
	public static function getEntryPid($id){
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('id,pid,oType')
							->from('#__sobipro_relations')
							->where('oType = "entry"')
							->where('id = ' .$id);
		$db->setQuery($query);
		$item = $db->loadObjectList();
		return $item;
	}
	
	public static function getField($id,$field,$id_c){
		$id_field = self::getIdField($field,$id_c);
		if($id_field == '')return'';
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('baseData')
							->from('#__sobipro_field_data')
							->where('sid = ' . $id)
							->where('fid = '.(int)$id_field);
		$db->setQuery($query);
		$item = $db->loadObject();
		if(count($item) == 0)return '';
		return $item->baseData;
	}
			
	public static function getIdField($field,$section){
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('fid')
							->from('#__sobipro_field')	
							->where('nid = "'.$field.'"')
							->where('section = '.$section);
		$db->setQuery($query);
		$item = $db->loadObject();		
		if(count($item) == 0)return '';
		return $item->fid;
	}
	
	public static function getFieldCountry($id,$field,$id_c){
		$id_field = self::getIdField($field,$id_c);
		if($id_field == '')return'';
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('optValue')
							->from('#__sobipro_field_option_selected')
							->where('sid = ' . $id)
							->where('fid = '.(int)$id_field);
		$db->setQuery($query);
		$item = $db->loadObject();
		if(count($item) == 0) return '';
		return $item->optValue;
	}
	
	public static function getEntryImage($id,$field,$id_c){
		$id_field = self::getIdField($field,$id_c);	
		if($id_field == '')return'';
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('baseData')
							->from('#__sobipro_field_data')
							->where('sid = ' . $id)
							->where('fid = '.$id_field);
		$db->setQuery($query);
		$item = $db->loadObject();
		if(count($item) == 0)return '';
		$data = $item->baseData;
		$json = base64_decode($data);
		$string = strstr($json,"/thumb_");
		$index = strpos($string,'"');
		$return = substr($string,1,($index-1));
		return $return;
	}
	
	public static function getEntryName($id){
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true)
							->select('nid,name')
							->from('#__sobipro_object')
							->where('id = ' . $id);
		$db->setQuery($query);
		$item = $db->loadObject();
		if(count($item) == 0)return '';
		return $item;
	}
	
	public static function getCategory($params){
		$cid    = $params->get('catid');
		$sid = $params->get('sid', 0);
		$db		= JFactory::getDbo();	
		$section = SPFactory::Section($sid);
		if($params->get('show_child_category_entries') == 1){
			$catids_all = $section->getChilds('category', true, 1);
		}else{
			$catids_all = $params->get('catid');
		}
		
		$select_array = '(' .implode(',',$catids_all). ')';
		$query	= $db->getQuery(true)->select('r.id,r.pid,r.oType,o.name,o.nid')
									 ->from('#__sobipro_relations as r')
									 ->where('r.oType = "category"')
									 ->where('r.id in ' . $select_array)
									 ->join('inner','#__sobipro_object as o on (r.id = o.id)');
		$db->setQuery($query);
		$items = $db->loadAssocList();			
		$list = array();
		foreach($items as $item){
			$list[$item['id']] = $item;
		}
		return $list;
	}
	
	public static function getInfoCategory($params){
		$sid = $params->get('sid', 0);
		$db		= JFactory::getDbo();	
		$section = SPFactory::Section($sid);
		$catids_all = $section->getChilds('category', true, 1);
		$select_array = '(' .implode(',',$catids_all). ')';
		$query	= $db->getQuery(true)->select('r.id,r.pid,r.oType,o.name,o.nid')
									 ->from('#__sobipro_relations as r')
									 ->where('r.oType = "category"')
									 ->where('r.id in ' . $select_array)
									 ->join('inner','#__sobipro_object as o on (r.id = o.id)');
		$db->setQuery($query);
		$items = $db->loadAssocList();
		$list = array();
		foreach($items as $item){
			if(isset($list[$item['pid']])){
				$list[$item['pid']][] = $item['id'];
			}else{
				$list[$item['pid']] = array();
				$list[$item['pid']][] = $item['id'];
			}			
		}
		return $list;
	}	
	
	public static function showCategory($array,$category,$cInfo,$lv,$max,$array_categori){
		$__ = '';
		for($i = 1; $i <= $lv;$i++){
			$__ = $__ . ' - ';
		}
		foreach($array as $id){
			if(isset($array_categori[$category[$id]['nid']])){
				$class = ' ' . $array_categori[$category[$id]['nid']];
			}else{
				$class = '';
			}
			echo '<p class="sj_category_geomap sj_icon sj_show '.$category[$id]['nid'].''.$class.'" data-level="'.$lv.'" data-category="'.$category[$id]['nid'].'">'.$__.$category[$id]['name'].'</p>';
			if($lv >= $max) continue;
			if(!isset($cInfo[$id]))continue;
			self::showCategory($cInfo[$id],$category,$cInfo,$lv+1,$max,$array_categori);
		}
	}
	/* ---------------------------------------------------------------------------------------------- */
}



